import pytest
from mlair.data_handler.default_data_handler import DefaultDataHandler
from mlair.data_handler.data_handler_single_station import DataHandlerSingleStation
from mlair.helpers.testing import get_all_args


class TestDefaultDataHandler:

    def test_requirements(self):
        reqs = get_all_args(DefaultDataHandler)
        obj = object.__new__(DefaultDataHandler)
        assert sorted(obj.own_args()) == reqs
        reqs = get_all_args(DataHandlerSingleStation, remove="self")
        assert sorted(obj._requirements) == reqs
        reqs = get_all_args(DefaultDataHandler, DataHandlerSingleStation, remove=["self", "id_class"])
        assert sorted(obj.requirements()) == reqs
        reqs = get_all_args(DefaultDataHandler, DataHandlerSingleStation, remove=["self", "id_class", "station"])
        assert sorted(obj.requirements(skip_args="station")) == reqs





